
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: group.h,v 1.1 2000/10/11 20:04:05 pink Exp pink $ */

#ifndef _GROUP_H_
#define _GROUP_H_

#include "main.h"

#define GROUP_DELETED   0x00000001

class group {
 protected:
  char *_name;
  Uint32 _id;

  Sint32 _xpos, _ypos;
  Sint32 _xvel, _yvel;
  Sint32 _xacc, _yacc;

  Uint32 _flags;

  Uint32 _last_time;

  struct object **_objects;
  Uint16 _objects_count;

 public:
  group(const char *, Uint32);
  virtual ~group();

  const char *name() const { return( _name ); }
  Uint32 id() const { return( _id ); }

  Sint16 xpos() const { return( _xpos >> 8 ); }
  void xpos(Sint16 x) { _xpos = x << 8; }
  Sint16 ypos() const { return( _ypos >> 8 ); }
  void ypos(Sint16 y) { _ypos = y << 8; }
  Sint16 xvel() const { return( _xvel >> 8 ); }
  void xvel(Sint16 x) { _xvel = x << 8; }
  Sint16 yvel() const { return( _yvel >> 8 ); }
  void yvel(Sint16 y) { _yvel = y << 8; }
  Sint16 xacc() const { return( _xacc >> 8 ); }
  void xacc(Sint16 x) { _xacc = x << 8; }
  Sint16 yacc() const { return( _yacc >> 8 ); }
  void yacc(Sint16 y) { _yacc = y << 8; }

  Uint32 flags() const { return( _flags ); }
  void flags(Uint32 f) { _flags = f; }

  void add_object(class object *);
  void rem_object(class object *);

  virtual void initialize();
  virtual void move();
  virtual void destroy();

  static bool setup();
  static void cleanup();
};

#endif





