%option noyywrap

%{
#include <stdlib.h>
#include "level.h"
#define YYSTYPE ldl_node *
#include "level_parser.h"

int lexer_line_number = 1;
char *lexer_file_name = "";

void lexer_setup();
void lexer_cleanup();
%}

%%

[\t ]+			        /* ignore spaces */
"#".*(\r\n|\n|\r)		++lexer_line_number;
\r\n|\n|\r		        ++lexer_line_number; 
"FINISH"		        return( FINISH );
"OBJECT"			return( OBJECT );
"BONUS"				return( BONUS );
"WHILE"				return( WHILE );
"REPEAT"			return( REPEAT );
"IF"				return( IF );
"TRIGGER"			return( TRIGGER );
"SUB"				return( SUB );
"CALL"				return( CALL );
"POS"				return( POSITION );
"POSITION"			return( POSITION );
"REL"				return( RELATIVE );
"RELATIVE"			return( RELATIVE );
"SIG"				return( SIGNAL );
"SIGNAL"			return( SIGNAL );
"TIME"				return( TIME );
"DEFINE"			return( DEFINE );
"+"				return( OP_ADD );
"-"				return( OP_SUB );
"*"				return( OP_MUL );
"/"				return( OP_DIV );
"%"				return( OP_MOD );
"<"				return( OP_LT );
"<="				return( OP_LE );
">"				return( OP_GT );
">="				return( OP_GE );
"=="				return( OP_EQ );
"!="				return( OP_NE );
([a-z_])([a-zA-Z_0-9])*		yylval = new ldl_node_string(yytext); return( IDENTIFIER );
"0x"([0-9a-fA-F])+		yylval = new ldl_node_int(strtol(yytext, NULL, 0)); return( NUMBER );
([0-9])+			yylval = new ldl_node_int(atoi(yytext)); return( NUMBER );
.				return( yytext[0] );
%%

void lexer_setup() {
}

void lexer_cleanup() {
}
