
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_blocker.h,v 1.1 2000/10/11 20:04:05 pink Exp pink $ */

#ifndef _OBJECT_BLOCKER_H_
#define _OBJECT_BLOCKER_H_

#include "object.h"
#include "group.h"

class object_blocker : public object {
 protected:
  static Uint16 _image_id;

  Sint32 _dir;
  Uint16 _shot_trigger;
  class group_blocker *_group;
  Uint16 _phase;
  bool _shot_enabled;
  Uint16 _group_id;
  Uint16 _group_member;

 public:
  object_blocker();
  ~object_blocker();

  void set_modifiers(svector<object_modifier> &);
  void handle_trigger(Uint16);
  Uint16 current_frame(part *) const;
  void move();
  void destroy();
  void initialize();

  static object *constructor();
  static bool setup();
  static void cleanup();

  Sint16 dir() const { return(_dir >> 8); }
  void dir(Sint16 d) { _dir = d << 8; }
};

class group_blocker : public group {
 protected:
  Sint32 _angle;

 public:
  group_blocker(Uint32);

  Sint32 angle() const { return( _angle ); }

  void move();
  void destroy();
  void initialize();

  static group *constructor(Uint32);
  static bool setup();
  static void cleanup();
};

#endif
