
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_delta.cc,v 1.1 2000/10/11 20:04:05 pink Exp pink $ */

#include <stdlib.h>
#include "main.h"
#include "game.h"
#include "object_delta.h"
#include "object_expl.h"

//$TAB { "delta", object_delta::constructor, object_delta::setup, object_delta::cleanup },

Uint16 object_delta::_image_id = 0xffff;

object_delta::object_delta() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  p->_frames_per_second = 16;
  p->_frames_reverse = (rand() & 16) ? true : false;
  update_size();

  xpos( rand() % g->map_width() );
  ypos( -height() );
  xvel( 0 );
  yvel( 80 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_ENEMIES;

  _hit_mask = OBJECT_PLAYER_SHIP | OBJECT_PLAYER_PROJECTILE;
  _type_mask = OBJECT_ENEMY_SHIP;


  _energy = 200;
  _score = 250;
}

void object_delta::destroy() {
  object::destroy();

  g->play_expl_sound(SOUND_EXPL_1, SOUND_LAYER_ENEMY, 80);

  for ( int i = 0 ; i < 6 ; ++i ) {
    object *o = new object_expl3();
    o->xpos(xpos());
    o->ypos(ypos());
    o->xvel((75 + (rand() % 150)) * ((rand() & 16) ? -1 : 1));
    o->yvel((75 + (rand() % 150)) * ((rand() & 16) ? -1 : 1));
    g->add_object(o);
  }

  object *o = new object_expl1();
  o->xpos(xpos());
  o->ypos(ypos());
  o->xvel(xvel());
  o->yvel(yvel());
  g->add_object(o);
}

object *object_delta::constructor() {
  return( new object_delta() );
}

bool object_delta::setup() {
  if ( object::setup() &&
       object_expl1::setup() &&
       object_expl3::setup() ) {
    _image_id = g->obtain_bob("delta");
    if ( _image_id != 0xffff )
      return( true );
  }

  return( false );
}

void object_delta::cleanup() {
  g->release_bob(_image_id);

  object_expl3::cleanup();
  object_expl1::cleanup();
  object::cleanup();
}
