
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_glider.h,v 1.1 2000/10/11 20:04:05 pink Exp pink $ */

#ifndef _OBJECT_GLIDER_H_
#define _OBJECT_GLIDER_H_

#include "object.h"

class object_glider : public object {
 protected:
  static Uint16 _image_id;

  Sint32 _dir;
  Uint16 _target;
  Sint16 _target_x[10], _target_y[10];

  Uint16 _shot_trigger;

  Uint16 _group_id;
  Uint16 _group_member;

 public:
  object_glider();

  void set_modifiers(svector<object_modifier> &);
  void handle_trigger(Uint16);
  Uint16 current_frame(part *) const;
  void move();
  void destroy();
  void initialize();

  static object *constructor();
  static bool setup();
  static void cleanup();

  Sint16 dir() const { return(_dir >> 8); }
  void dir(Sint16 d) { _dir = d << 8; }
};

#endif
