
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_projectile.cc,v 1.1 2000/10/11 20:04:05 pink Exp pink $ */

#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "game.h"
#include "object_projectile.h"
#include "object_expl.h"

/***************************************************************
 *                                                             *
 * class object_plasma1                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma1::_image_id = 0xffff;

object_plasma1::object_plasma1() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -180 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 150;
}

bool object_plasma1::setup() {
  _image_id = g->obtain_bob("plasm1");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma1::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma1l                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma1l::_image_id = 0xffff;

object_plasma1l::object_plasma1l() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( -47 );
  yvel( -174 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 150;
}

bool object_plasma1l::setup() {
  _image_id = g->obtain_bob("plasm1l");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma1l::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma1r                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma1r::_image_id = 0xffff;

object_plasma1r::object_plasma1r() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 47 );
  yvel( -174 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 150;
}

bool object_plasma1r::setup() {
  _image_id = g->obtain_bob("plasm1r");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma1r::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma2                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma2::_image_id = 0xffff;

object_plasma2::object_plasma2() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -180 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 250;
}

bool object_plasma2::setup() {
  _image_id = g->obtain_bob("plasm2");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma2::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma2l                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma2l::_image_id = 0xffff;

object_plasma2l::object_plasma2l() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( -62 );
  yvel( -169 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 250;
}

bool object_plasma2l::setup() {
  _image_id = g->obtain_bob("plasm2l");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma2l::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma2r                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma2r::_image_id = 0xffff;

object_plasma2r::object_plasma2r() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 62 );
  yvel( -169 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 250;
}

bool object_plasma2r::setup() {
  _image_id = g->obtain_bob("plasm2r");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma2r::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma3                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma3::_image_id = 0xffff;

object_plasma3::object_plasma3() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -180 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 400;
}

bool object_plasma3::setup() {
  _image_id = g->obtain_bob("plasm3");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma3::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma3l                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma3l::_image_id = 0xffff;

object_plasma3l::object_plasma3l() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( -90 );
  yvel( -156 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 400;
}

bool object_plasma3l::setup() {
  _image_id = g->obtain_bob("plasm3l");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma3l::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_plasma3r                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_plasma3r::_image_id = 0xffff;

object_plasma3r::object_plasma3r() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 90 );
  yvel( -156 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 400;
}

bool object_plasma3r::setup() {
  _image_id = g->obtain_bob("plasm3r");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_plasma3r::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_laser1                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_laser1::_image_id = 0xffff;

object_laser1::object_laser1() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -360 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 100;
}

bool object_laser1::setup() {
  _image_id = g->obtain_bob("laser1");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_laser1::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_laser2                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_laser2::_image_id = 0xffff;

object_laser2::object_laser2() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -360 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 250;
}

bool object_laser2::setup() {
  _image_id = g->obtain_bob("laser2");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_laser2::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_laser3                                         *
 *                                                             *
 ***************************************************************/

Uint16 object_laser3::_image_id = 0xffff;

object_laser3::object_laser3() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -360 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 400;
}

bool object_laser3::setup() {
  _image_id = g->obtain_bob("laser3");
  
  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_laser3::cleanup() {
  g->release_bob(_image_id);
}

/***************************************************************
 *                                                             *
 * class object_ball1                                           *
 *                                                             *
 ***************************************************************/

Uint16 object_ball1::_image_id = 0xffff;

object_ball1::object_ball1() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -210 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 120;
}

void object_ball1::hit(object *) {
  Sint32 vx = ((rand() % 50) + 50) * ((rand() & 1) ? -1 : 1);
  Sint32 vy = ((rand() % 50) + 50) * ((rand() & 1) ? -1 : 1);

  double ovel = 1.2 * sqrt(xvel() * xvel() + yvel() * yvel());
  double nvel = sqrt(vx * vx + vy * vy);
  
  xvel((Sint16)(ovel * vx / nvel));
  yvel((Sint16)(ovel * vy / nvel));
}

void object_ball1::destroy() {
  object::destroy();

  object *o = new object_expl3();
  o->xpos(xpos() + (width() - o->width()) / 2);
  o->ypos(ypos() + (height() - o->height()) / 2);
  o->xvel(xvel());
  o->yvel(yvel());
  g->add_object(o);
}

bool object_ball1::setup() {
  if ( object_expl3::setup() ) {
    _image_id = g->obtain_bob("ball1");
  
    if ( _image_id != 0xffff )
      return( true );
  }

  return( false );
}

void object_ball1::cleanup() {
  g->release_bob(_image_id);

  object_expl3::cleanup();
}

/***************************************************************
 *                                                             *
 * class object_ball2                                           *
 *                                                             *
 ***************************************************************/

Uint16 object_ball2::_image_id = 0xffff;

object_ball2::object_ball2() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -180 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 350;
}

void object_ball2::hit(object *) {
  Sint32 vx = ((rand() % 50) + 50) * ((rand() & 1) ? -1 : 1);
  Sint32 vy = ((rand() % 50) + 50) * ((rand() & 1) ? -1 : 1);

  double ovel = 1.2 * sqrt(xvel() * xvel() + yvel() * yvel());
  double nvel = sqrt(vx * vx + vy * vy);
  
  xvel((Sint16)(ovel * vx / nvel));
  yvel((Sint16)(ovel * vy / nvel));
}

void object_ball2::destroy() {
  object::destroy();

  object *o = new object_expl3();
  o->xpos(xpos() + (width() - o->width()) / 2);
  o->ypos(ypos() + (height() - o->height()) / 2);
  o->xvel(xvel());
  o->yvel(yvel());
  g->add_object(o);
}

bool object_ball2::setup() {
  if ( object_expl3::setup() ) {
    _image_id = g->obtain_bob("ball2");
  
    if ( _image_id != 0xffff )
      return( true );
  }

  return( false );
}

void object_ball2::cleanup() {
  g->release_bob(_image_id);

  object_expl3::cleanup();
}

/***************************************************************
 *                                                             *
 * class object_ball3                                           *
 *                                                             *
 ***************************************************************/

Uint16 object_ball3::_image_id = 0xffff;

object_ball3::object_ball3() : object() {
  part *p = add_part(0);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -150 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  _energy = 1000;
}

void object_ball3::hit(object *) {
  Sint32 vx = ((rand() % 50) + 50) * ((rand() & 1) ? -1 : 1);
  Sint32 vy = ((rand() % 50) + 50) * ((rand() & 1) ? -1 : 1);

  double ovel = 1.2 * sqrt(xvel() * xvel() + yvel() * yvel());
  double nvel = sqrt(vx * vx + vy * vy);
  
  xvel((Sint16)(ovel * vx / nvel));
  yvel((Sint16)(ovel * vy / nvel));
}

void object_ball3::destroy() {
  object::destroy();

  object *o = new object_expl3();
  o->xpos(xpos() + (width() - o->width()) / 2);
  o->ypos(ypos() + (height() - o->height()) / 2);
  o->xvel(xvel());
  o->yvel(yvel());
  g->add_object(o);
}

bool object_ball3::setup() {
  if ( object_expl3::setup() ) {
    _image_id = g->obtain_bob("ball3");
  
    if ( _image_id != 0xffff )
      return( true );
  }

  return( false );
}

void object_ball3::cleanup() {
  g->release_bob(_image_id);

  object_expl3::cleanup();
}

/***************************************************************
 *                                                             *
 * class object_seeker                                           *
 *                                                             *
 ***************************************************************/

Uint16 object_seeker::_image_id[3] = { 0xffff, 0xffff, 0xffff };

object_seeker::object_seeker(int t) : object() {
  part *p = add_part(1);
  p->_surface = g->get_bob(_image_id[t]);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames();
  update_size();

  xpos( 0 );
  ypos( 0 );
  xvel( 0 );
  yvel( -210 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_PROJECTILES;

  _hit_mask = OBJECT_ENEMY_SHIP;
  _type_mask = OBJECT_PLAYER_PROJECTILE;

  switch ( t ) {
  case 0 :
    _energy = 500;
    _dvel = 200 << 8;
    _vel = 300;
    break;
  case 1 :
    _energy = 750;
    _dvel = 160 << 8;
    _vel = 230;
    break;
  case 2 :
    _energy = 1000;
    _dvel = 130 << 8;
    _vel = 150;
    break;
  }
}

void object_seeker::handle_trigger(Uint16 id) {
  if ( id == _target_trigger ) {
    _target_trigger = get_trigger();
    set_trigger(_target_trigger, 500);

    object *target = NULL;
    Sint32 target_dist = 0;

    for ( object **oscan = g->first_object() ; oscan ; oscan = g->next_object(oscan) ) {
      if ( (*oscan)->type_mask() & OBJECT_ENEMY_SHIP ) {
	Sint32 dx = ((*oscan)->xpos() - xpos());
	Sint32 dy = ((*oscan)->ypos() - ypos());
	Sint32 dist = dx * dx + dy * dy;

	if ( !target || (dist < target_dist) ) {
	  target = *oscan;
	  target_dist = dist;
	}
      }
    }

    if ( target ) {
      _target_enabled = true;
      _target_x = target->xpos();
      _target_y = target->ypos();
    }
    else
      _target_enabled = false;
  }

  object::handle_trigger(id);
}

Uint16 object_seeker::current_frame(part *p) const {
  Sint16 f;

  switch ( p->_id ) {
  case 1 :
    f = (p->_frames_count * (_dir >> 8) / 360) % p->_frames_count;
    break;

  default :
    f = object::current_frame(p);
    break;
  }

  return( f );
}

void object_seeker::initialize() {
  _target_trigger = get_trigger();
  set_trigger(_target_trigger, 500);
  _target_enabled = false;

  double d;
  double dx = xvel();
  double dy = yvel();

  if ( dy > 0 )
    d = atan(-dx / dy) + 2 * M_PI;
  else if ( dy < 0 )
    d = atan(-dx / dy) + M_PI;
  else if ( dx > 0 )
    d = 1.5 * M_PI;
  else
    d = 0.5 * M_PI;

  _dir = ((Sint16)(180.0 * d / M_PI) % 360) << 8;
}

void object_seeker::move() {
  if ( _target_enabled ) {
    double dx = _target_x - xpos();
    double dy = _target_y - ypos();
    double d;
  
    if ( dy > 0 )
      d = atan(-dx / dy) + 2 * M_PI;
    else if ( dy < 0 )
      d = atan(-dx / dy) + M_PI;
    else if ( dx > 0 )
      d = 1.5 * M_PI;
    else
      d = 0.5 * M_PI;

    Sint16 nd = (Sint16)(180.0 * d / M_PI) % 360;
    Sint16 od = (_dir >> 8) % 360;

    Sint32 dvel = 0;
    if ( abs(nd - od) > 10 ) {
      if ( nd > od ) {
	if ( nd - od < 180 )
	  dvel = _dvel;
	else
	  dvel = -_dvel;
      }
      else if ( nd < od ) {
	if ( od - nd < 180 )
	  dvel = -_dvel;
	else
	  dvel = _dvel;
      }
    }

    _dir += (Sint32)(g->current_time() - _last_time) * dvel / 1000;
    while ( _dir < 0 )
      _dir += 360 << 8;
  }

  double d = M_PI * (_dir >> 8) / 180.0;

  xvel((Sint16)(-_vel * sin(d)));
  yvel((Sint16)(_vel * cos(d)));

  object::move();
}

void object_seeker::destroy() {
  object::destroy();

  object *o = new object_expl3();
  o->xpos(xpos() + (width() - o->width()) / 2);
  o->ypos(ypos() + (height() - o->height()) / 2);
  o->xvel(xvel());
  o->yvel(yvel());
  g->add_object(o);
}

bool object_seeker::setup() {
  if ( object_expl3::setup() ) {
    _image_id[0] = g->obtain_bob("seeker1");
    _image_id[1] = g->obtain_bob("seeker2");
    _image_id[2] = g->obtain_bob("seeker3");
  
    if ( (_image_id[0] != 0xffff) && (_image_id[1] != 0xffff) && (_image_id[2] != 0xffff) )
      return( true );
  }

  return( false );
}

void object_seeker::cleanup() {
  g->release_bob(_image_id[0]);
  g->release_bob(_image_id[1]);
  g->release_bob(_image_id[2]);

  object_expl3::cleanup();
}
