
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_projectile.h,v 1.1 2000/10/11 20:04:05 pink Exp pink $ */

#ifndef _OBJECT_PROJECTILE_H_
#define _OBJECT_PROJECTILE_H_

#include "object.h"

class object_plasma1 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma1();

  static bool setup();
  static void cleanup();
};

class object_plasma1l : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma1l();

  static bool setup();
  static void cleanup();
};

class object_plasma1r : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma1r();

  static bool setup();
  static void cleanup();
};

class object_plasma2 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma2();

  static bool setup();
  static void cleanup();
};

class object_plasma2l : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma2l();

  static bool setup();
  static void cleanup();
};

class object_plasma2r : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma2r();

  static bool setup();
  static void cleanup();
};

class object_plasma3 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma3();

  static bool setup();
  static void cleanup();
};

class object_plasma3l : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma3l();

  static bool setup();
  static void cleanup();
};

class object_plasma3r : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_plasma3r();

  static bool setup();
  static void cleanup();
};


class object_laser1 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_laser1();

  static bool setup();
  static void cleanup();
};

class object_laser2 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_laser2();

  static bool setup();
  static void cleanup();
};

class object_laser3 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_laser3();

  static bool setup();
  static void cleanup();
};


class object_ball1 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_ball1();

  void hit(object *);
  void destroy();

  static bool setup();
  static void cleanup();
};

class object_ball2 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_ball2();

  void hit(object *);
  void destroy();

  static bool setup();
  static void cleanup();
};

class object_ball3 : public object {
 protected:
  static Uint16 _image_id;

 public:
  object_ball3();

  void hit(object *);
  void destroy();

  static bool setup();
  static void cleanup();
};

class object_seeker : public object {
 protected:
  static Uint16 _image_id[3];

  Uint16 _target_trigger;
  bool _target_enabled;
  Uint16 _target_x;
  Uint16 _target_y;
  void handle_trigger(Uint16);

  Sint32 _dir;
  Sint32 _vel;
  Sint32 _dvel;

 public:
  object_seeker(int);

  Uint16 current_frame(part *) const;
  void initialize();
  void move();
  void destroy();

  static bool setup();
  static void cleanup();

  Sint16 dir() const { return(_dir >> 8); }
  void dir(Sint16 d) { _dir = d << 8; }
};

#endif
