
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_smoke.cc,v 1.1 2000/10/11 20:04:06 pink Exp pink $ */

#include <stdlib.h>
#include "main.h"
#include "game.h"
#include "object_smoke.h"

/*******************************************************************
 *                                                                 *
 * class object_smoke1                                              *
 *                                                                 *
 *******************************************************************/

Uint16 object_smoke1::_image_id = 0xffff;

object_smoke1::object_smoke1() : object() {
  part *p = add_part(1);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_per_second = 12;
  p->_frames_count = p->_surface->frames();
  p->_frames_loops = 1;
  update_size();

  _layer = LAYER_EXPLOSIONS;

  _hit_mask = 0;
  _type_mask = OBJECT_NEUTRAL;
}

void object_smoke1::finish_phase(part *p) {
  if ( p->_id == 1 )
    _flags |= OBJECT_DELETED;

  object::finish_phase(p);
}

bool object_smoke1::setup() {
  _image_id = g->obtain_bob("smoke1");

  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_smoke1::cleanup() {
  g->release_bob(_image_id);
}

/*******************************************************************
 *                                                                 *
 * class object_smoke2                                              *
 *                                                                 *
 *******************************************************************/

Uint16 object_smoke2::_image_id = 0xffff;

object_smoke2::object_smoke2() : object() {
  part *p = add_part(1);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_per_second = 10;
  p->_frames_count = p->_surface->frames();
  p->_frames_loops = 1;
  update_size();

  _layer = LAYER_EXPLOSIONS;

  _hit_mask = 0;
  _type_mask = OBJECT_NEUTRAL;
}

void object_smoke2::finish_phase(part *p) {
  if ( p->_id == 1 )
    _flags |= OBJECT_DELETED;

  object::finish_phase(p);
}

bool object_smoke2::setup() {
  _image_id = g->obtain_bob("smoke2");

  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_smoke2::cleanup() {
  g->release_bob(_image_id);
}

/*******************************************************************
 *                                                                 *
 * class object_smoke3                                              *
 *                                                                 *
 *******************************************************************/

Uint16 object_smoke3::_image_id = 0xffff;

object_smoke3::object_smoke3() : object() {
  part *p = add_part(1);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_per_second = 7;
  p->_frames_count = p->_surface->frames();
  p->_frames_loops = 1;
  update_size();

  _layer = LAYER_EXPLOSIONS;

  _hit_mask = 0;
  _type_mask = OBJECT_NEUTRAL;
}

void object_smoke3::finish_phase(part *p) {
  if ( p->_id == 1 )
    _flags |= OBJECT_DELETED;

  object::finish_phase(p);
}

bool object_smoke3::setup() {
  _image_id = g->obtain_bob("smoke3");

  if ( _image_id != 0xffff )
    return( true );

  return( false );
}

void object_smoke3::cleanup() {
  g->release_bob(_image_id);
}

