
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: object_thermo.cc,v 1.1 2000/10/11 20:04:06 pink Exp pink $ */

#include <stdlib.h>
#include "main.h"
#include "game.h"
#include "object_thermo.h"
#include "object_expl.h"

//$TAB { "thermo", object_thermo::constructor, object_thermo::setup, object_thermo::cleanup },

Uint16 object_thermo::_image_id = 0xffff;

object_thermo::object_thermo() : object() {
  part *p = add_part(1);
  p->_surface = g->get_bob(_image_id);
  p->_xoffset = -p->_surface->width() / 2;
  p->_yoffset = -p->_surface->height() / 2;
  p->_frames_count = p->_surface->frames() / 2;
  update_size();

  xpos( rand() % g->map_width() );
  ypos( -height() );
  xvel( 0 );
  yvel( 50 );
  xacc( 0 );
  yacc( 0 );

  _layer = LAYER_ENEMIES;

  _hit_mask = OBJECT_PLAYER_SHIP | OBJECT_PLAYER_PROJECTILE;
  _type_mask = OBJECT_ENEMY_SHIP;

  _zombie = 0;

  _energy = 400;
  _score = 650;
}

void object_thermo::destroy() {
  g->play_expl_sound(SOUND_EXPL_2, SOUND_LAYER_ENEMY);

  object *o = new object_expl1();
  o->xpos(xpos());
  o->ypos(ypos());
  o->xvel(xvel());
  o->yvel(yvel());
  g->add_object(o);

  if ( _zombie ) {
    if ( xvel() > 0 )
      xvel(-xvel() - (rand() % 50) - 20);
    else
      xvel(-xvel() + (rand() % 50) + 20);
  }
  else {
    xvel(((rand() & 16) ? -1 : 1) * ((rand() % 100) + 150));
    yvel(-(rand() % 30) - 30);
  }

  _energy = 500;
  _zombie++;
  part *p = get_part(1);
  if ( p )
    p->_frames_offset = p->_surface->frames() / 2;
}

object *object_thermo::constructor() {
  return( new object_thermo() );
}

bool object_thermo::setup() {
  if ( object::setup() &&
       object_expl1::setup() ) {
    _image_id = g->obtain_bob("thermo");
    if ( _image_id != 0xffff )
      return( true );
  }

  return( false );
}

void object_thermo::cleanup() {
  g->release_bob(_image_id);

  object_expl1::cleanup();
  object::cleanup();
}
