
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id: rectangle.h,v 1.1 2000/10/11 20:04:06 pink Exp pink $ */

#ifndef _RECTANGLE_H_
#define _RECTANGLE_H_

#include "SDL.h"

class rectangle {
 protected:
  SDL_Rect _rect;
  
 public:
  rectangle() {
    _rect.x = 0;
    _rect.y = 0;
    _rect.w = 0;
    _rect.h = 0;
  }

  rectangle(SDL_Rect *r) {
    _rect = *r;
  }

  rectangle(Sint16 x, Sint16 y, Uint16 w, Uint16 h) {
    _rect.x = x;
    _rect.y = y;
    _rect.w = w;
    _rect.h = h;
  }

  rectangle(const rectangle &r) {
    _rect = r._rect;
  }

  const SDL_Rect *rect() const { return( &_rect ); }
  Sint16 x() const { return( _rect.x ); }
  void x(Sint16 x) { _rect.x = x; }
  Sint16 y() const { return( _rect.y ); }
  void y(Sint16 y) { _rect.y = y; }
  Uint16 w() const { return( _rect.w ); }
  void w(Uint16 w) { _rect.w = w; }
  Uint16 h() const { return( _rect.h ); }
  void h(Uint16 h) { _rect.h = h; }
};

#endif
