
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id$ */

#ifndef _SARRAY_H_
#define _SARRAY_H_

#include <stdlib.h>
#include <assert.h>

template <class T> class sarray {
 private:
  T **_data;
  int _size;
  int _len;

 public:
  typedef T ** iterator;
  typedef T *const* const_iterator;

  sarray() {
    _data = new T *[8];
    _size = 8;
    _len = 0;
  }

  ~sarray() {
    for ( int i = 0 ; i < _len ; ++i )
      delete _data[i];
    delete[] _data;
  }

  int size() const { return( _len ); }
  void clear() { _len = 0; }

  iterator begin() { return( _data ); }
  iterator end() { return( _data + _len ); }
  const_iterator begin() const { return( _data ); }
  const_iterator end() const { return( _data + _len ); }

  sarray& operator+=(T *a) {
    for ( iterator i = begin() ; i != end() ; ++i ) {
      if ( *i == NULL ) {
	*i = a;
	return( *this );
      }
    }

    if ( _len == _size ) {
      T **tmp = new T *[_len + 16];
      for ( int i = 0 ; i < _len ; ++i )
	tmp[i] = _data[i];
      for ( int i = _len ; i < _len + 16 ; ++i )
	tmp[i] = NULL;

      delete[] _data;
      _data = tmp;
      _size = _len + 16;
    }

    _data[_len] = a;
    ++_len;

    return( *this );
  }

  sarray& operator-=(T *a) {
    for ( iterator i = begin() ; i != end() ; ++i ) {
      if ( *i == a )
	*i = NULL;
    }

    return( *this );
  }

  T *operator[](int idx) const {
    assert( (idx >= 0) && (idx < _len) );
    return( _data[idx] );
  }
};


#endif
