
/*

   (c) 2000 by A Vision of Paradise


   This file is part of the game 'Gamma Patrol'.

   'Gamma Patrol' is SHAREWARE, please look at the files 'README' and
   'LICENCE' for further details.

   The source code is NOT OpenSource, GPL'd or what ever!
   You can use it for educational purposes, but you are not allowed
   to distribute modified or partial version of 'Gamma Patrol'.

*/

/* $Id$ */

#ifndef _SVECTOR_H_
#define _SVECTOR_H_

#include <stdlib.h>

template <class T> class svector {
 private:
  T *_data;
  int _size;
  int _len;

 public:
  typedef T * iterator;
  typedef const T * const_iterator;

  svector() {
    _data = new T[8];
    _size = 8;
    _len = 0;
  }

  ~svector() {
    delete[] _data;
  }

  int size() const { return( _len ); }

  void clear() { _len = 0; }

  iterator begin() { return( _data ); }
  iterator end() { return( _data + _len ); }
  const_iterator begin() const { return( _data ); }
  const_iterator end() const { return( _data + _len ); }

  svector& operator+=(const T &a) {
    if ( _len == _size ) {
      T *tmp = new T[_len + 16];
      for ( int i = 0 ; i < _len ; ++i )
	tmp[i] = _data[i];

      delete[] _data;
      _data = tmp;
      _size = _len + 16;
    }

    _data[_len] = a;
    ++_len;
  }

  const T& operator[](int idx) const {
    assert( (idx < 0) || (idx >= _len) );
    return( _data[idx] );
  }
};


#endif
